#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

// try changing fonts for better readability
#ifdef HiRes
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
#define FreqLine      20
#define CursorLine    35
#define defaultText    1
#define biggerText     2
#else
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 32 // OLED display height, in pixels
#define FreqLine      10
#define CursorLine    25
#define defaultText    1
#define biggerText     2
#endif

// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
//#define OLED_RESET     4 // Reset pin # (or -1 if sharing Arduino reset pin)
//Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT);

void setup_display() {
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  display.clearDisplay();
  display.display();                  // Update screen
  display.setTextSize(defaultText);             // Normal 1:1 pixel scale
  display.setTextColor(WHITE,BLACK);  // Draw white text
  display.setCursor(0,0);             // Start at top-left corner
  display.println(F(Version));
  display.display(); // Update screen
  delay(1000);
}

/********************************
  update frequency and step-size
********************************/
void display_freq_step() {
     updateFlag = LOW;
   long MHz = frequency/1000000;

   // convert frequency to floating point
   // adding 0.0000001 fixes a rounding error
   double freq = (double) frequency/1000000+0.0000001;

   // display frequency
      display.clearDisplay();
      display.setCursor(20,0);                         // start at char 1, line 1 (5,0)
       if (last_sideband==0)
       { display.print("AM ");
       }
       else
      if (last_sideband==1)
       { display.print("USB");
       }
      if (last_sideband==2)
       { display.print("LSB");
       }
       
      display.setTextSize(biggerText);
   if (MHz < 10) {
     display.setCursor(24,FreqLine);                         // start at char 1, line 1
     display.print(freq, 5);                          // 5 digit resolution
   } else {
     display.setCursor(12,FreqLine);                          // start at char 1, line 1 (10,10)
     display.print(freq, 5);
   }
      display.setTextSize(defaultText);
      display.print("MHz ");
      display.display(); // Update screen
             
  // display step size
   switch (step_size) {
       display.setCursor(0,CursorLine);  // (0,25)                        // start at char 1, line 2
      display.print("                    ");   
        display.display(); // Update screen
        
 /*      case 1:                                  // added for 1xHz.
       display.setCursor(99,CursorLine);
       display.print("*");
       break;
*/
     case 10:
       display.setCursor(99,CursorLine);
       display.print("*");
       break;
     case 100:
       display.setCursor(87,CursorLine);
       display.print("*");
       break;
     case 1000:
       display.setCursor(75,CursorLine);
       display.print("*");
       break;
     case 10000:
       display.setCursor(63,CursorLine);
       display.print("*");
       break;
     case 100000:
       display.setCursor(51,CursorLine);
       display.print("*");
       break;
     default:
       break;
   }
   display.display();
}
